﻿/*
 * Developer : Matt Smith (matt@matt40k.co.uk)
 * All code (c) Matthew Smith all rights reserved
 */

using System;
using System.Diagnostics;
using System.IO;

namespace Matt40k.MSICreator
{
    public class Worker
    {
        public string _simsserver { get; set; }
        public string _simsdatabase { get; set; }
        public string _simsauthenication { get; set; }
        public string _simsappsdirectory { get; set; }
        public string _simsdirectory { get; set; }
        public string _simssetupsdirectory { get; set; }
        private string _guid { get; set; }
        private string _version { get; set; }

        private string GetGUID
        {
            get
            {
                Guid g = Guid.NewGuid();
                return g.ToString();
            }
        }

        public void CreateInstaller()
        {
            _guid = GetGUID;
            _version = GetFileVersion;
            try
            {
                if (File.Exists("Installer.wxs"))
                    File.Delete("Installer.wxs");
            }
            catch (Exception CreateInstaller_DeleteInstaller_Exception)
            {

            }
            int lineNumber = 1;
            string line = null;

            try
            {
                using (TextReader tr = File.OpenText("Template.wxs"))
                using (TextWriter tw = File.CreateText("Installer.wxs"))
                {

                    while ((line = tr.ReadLine()) != null)
                    {
                        if (lineNumber == 1)
                        {
                            line = line.Replace("{{SIMSSERVER}}", _simsserver);
                            line = line.Replace("{{SIMSDATABASE}}", _simsdatabase);
                            line = line.Replace("{{SIMSAUTHENICATION}}", _simsauthenication);
                            line = line.Replace("{{SIMSAPPSDIRECTORY}}", _simsappsdirectory);
                            line = line.Replace("{{SIMSDIRECTORY}}", _simsdirectory);
                            line = line.Replace("{{SIMSSETUPSDIRECTORY}}", _simssetupsdirectory);
                            line = line.Replace("{{PRODUCT}}", _guid);
                            line = line.Replace("{{VERSION}}", _version);
                        }
                        tw.WriteLine(line);
                        lineNumber++;
                    }
                }
            }
            catch (Exception CreateInstaller_CreateInstaller_Exception)
            {

            }

            try
            {
                Process prc1 = new Process();
                prc1.StartInfo.FileName = "candle.exe";
                prc1.StartInfo.Arguments = "Installer.wxs";
                prc1.Start();
                prc1.WaitForExit();
            }
            catch (Exception CreateInstaller_Candle_Exception)
            {

            }

            try
            {
                Process prc2 = new Process();
                prc2.StartInfo.FileName = "light.exe";
                prc2.StartInfo.Arguments = "-ext WixUIExtension -ext WixUtilExtension Installer.wixobj";
                prc2.Start();
                prc2.WaitForExit();
            }
            catch (Exception CreateInstaller_Light_Exception)
            {

            }
        }

        private string GetFileVersion
        {
            get
            {
                try
                {
                    FileVersionInfo fileVersion = FileVersionInfo.GetVersionInfo(Path.Combine(_simssetupsdirectory, "SIMSSQLApplicationSetup.exe"));
                    return fileVersion.FileVersion;
                }
                catch (Exception GetFileVersion_Exception)
                {
                    
                }
                return "0.0.0.0";
            }
        }
    }
}
